#include <amxmodx>
#include <engine>

#include <colors>

#define PLUGIN "Objectives Message"
#define VERSION "1.1"
#define AUTHOR "R3X"

#define OBJ_BOMB (1<<0)
#define OBJ_HOSTAGE (1<<1)
#define OBJ_VIP (1<<2)
#define OBJ_ESCAPE (1<<3)

#define TASK_MESS 1

new g_Objectives=0;
new bool:gPlanted=false;
new gcvarRT, gcvarBefore;
new gcvarMessColor, gcvarMessPosX, gcvarMessPosY;

new Float:gPosX, Float:gPosY, gColor[3];

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	colors_init();
	register_dictionary("objectives.txt");
	register_logevent( "eventRoundStart",2, "1=Round_Start");
	register_logevent( "eventRoundEnd",2, "1=Round_End");
	register_event("BombDrop","eventPlant","a", "4=1");
	setObjectives();
	gcvarRT=get_cvar_pointer("mp_roundtime");
	gcvarBefore=register_cvar("amx_objectives_message","50.0",_,50.0);
	
	gcvarMessColor=register_cvar("amx_objectives_mess_color", "white");
	gcvarMessPosX=register_cvar("amx_objectives_mess_posx", "-1.0", 0, -1.0);
	gcvarMessPosY=register_cvar("amx_objectives_mess_posy", "0.12", 0, 0.12);
}
public eventPlant()
	gPlanted=true;
public eventRoundStart(){
	new Float:fTime=get_pcvar_float(gcvarRT)*60 - get_pcvar_float(gcvarBefore);
	set_task(fTime, "showMessages",TASK_MESS);
	getValues();
	gPlanted=false;
}
public eventRoundEnd()
	if(task_exists(TASK_MESS))
		remove_task(TASK_MESS);
public showMessages(tid){
	if(g_Objectives==0) return;
	new Players[32];
	new playerCount, id;
	new iLen, szMessage[64];
	new iTeam;
	new bool:show;
	get_players(Players, playerCount);
	for ( new i=0; i<playerCount; iLen=0,show=false,i++){
		id = Players[i];
		iTeam=get_user_team(id);
		iLen+=formatex(szMessage[iLen], 63, "%L: ", id, "OBJ");
		if(iTeam==1){
			if(!gPlanted && g_Objectives&OBJ_BOMB){
				iLen+=formatex(szMessage[iLen], 63, "[%L]", id, "OBJ_BOMB");
				show=true;
			}
			if(g_Objectives&OBJ_ESCAPE){
				iLen+=formatex(szMessage[iLen], 63, "[%L]", id, "OBJ_ESCAPE");
				show=true;
			}
		}else if(iTeam==2){
			if(gPlanted && g_Objectives&OBJ_BOMB){
				iLen+=formatex(szMessage[iLen], 63, "[%L]", id, "OBJ_BOMB_DEF");
				show=true;
			}
			if(g_Objectives&OBJ_HOSTAGE){
				iLen+=formatex(szMessage[iLen], 63, "[%L]", id, "OBJ_HOSTAGE");
				show=true;
			}
			if(g_Objectives&OBJ_VIP){
				show=true;
				iLen+=formatex(szMessage[iLen], 63, "[%L]", id, "OBJ_VIP");
			}
		}
		if(show){
			set_hudmessage(gColor[0], gColor[1], gColor[2], gPosX, gPosY,0,0.0,5.0,0.0,1.0);
			show_hudmessage(id, "%s", szMessage);
		}
	}
	
}
setObjectives(){
	//Detect:Bomb
	new ent1=find_ent_by_class ( -1, "func_bomb_target");
	new ent2=find_ent_by_class ( -1, "info_bomb_target");
	if(ent1 || ent2)
		g_Objectives|=OBJ_BOMB;
	//Detect:Hostage
	ent1=find_ent_by_class ( -1, "func_hostage_rescue");
	ent2=find_ent_by_class ( -1, "info_hostage_rescue");
	if(ent1 || ent2)
		g_Objectives|=OBJ_HOSTAGE;
	//Detect:Vip
	ent1=find_ent_by_class ( -1, "func_vip_safetyzone");
	if(ent1)
		g_Objectives|=OBJ_VIP;
	//Detect:Escape
	ent1=find_ent_by_class ( -1, "func_escapezone");
	if(ent1)
		g_Objectives|=OBJ_ESCAPE;
}
public getValues(){
	gPosX=get_pcvar_float(gcvarMessPosX);
	gPosY=get_pcvar_float(gcvarMessPosY);
	new szColor[COLORS_NAME_LEN];
	get_pcvar_string(gcvarMessColor, szColor, COLORS_NAME_LEN-1);
	if(!get_full_color(szColor, gColor)){
		log_amx("%L", LANG_SERVER, "BAD_COLOR");
		gColor[0]=255;
		gColor[1]=255;
		gColor[2]=255;
	}
}